#include "main.h"

#ifdef WIN64

#include <windows.h>

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

void* CBR_CreateWindow(CBR_CreateWindowParams params) {
	HWND hwnd;
	WNDCLASSW wc = *(WNDCLASSW*)params.params;
	RegisterClassW(params.params);
	LPWSTR title;
	MultiByteToWideChar(CP_UTF8, 0, params.title, -1, title, 0);
	hwnd = CreateWindowW(
		wc.lpszClassName,
		title, // TODO fix
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		params.rect.x, params.rect.y, params.rect.width, params.rect.height,
		NULL, NULL,
		wc.hInstance,
		NULL
	);

	return hwnd;
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PWSTR pCmdLine, int nCmdShow) {
	WNDCLASSW wc = {
		.style         = CS_HREDRAW | CS_VREDRAW,
		.cbClsExtra    = 0,
		.cbWndExtra    = 0,
		.lpszClassName = L"Window",
		.hInstance     = hInstance,
		.hbrBackground = GetSysColorBrush(COLOR_3DFACE),
		.lpszMenuName  = NULL,
		.lpfnWndProc   = WndProc,
		.hCursor       = LoadCursor(NULL, IDC_ARROW),
		.hIcon         = LoadIcon(NULL, IDI_APPLICATION),
	};

	HWND hwnd = CBR_CreateWindow((CBR_CreateWindowParams){
		.rect = (CBR_Rect){
			WINDOW_X,
			WINDOW_Y,
			WINDOW_WIDTH,
			WINDOW_HEIGHT
		},
		.style_flags =
			CBR_WINDOW_STYLE_FLAG_TITLED
			| CBR_WINDOW_STYLE_FLAG_CLOSABLE
			| CBR_WINDOW_STYLE_FLAG_MINIATURIZABLE
			| CBR_WINDOW_STYLE_FLAG_RESIZABLE,
		.title = "Window Title",
		.params = &wc
	});

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0)) {
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg,
												 WPARAM wParam, LPARAM lParam) {

	switch(msg) {

		case WM_DESTROY:

			PostQuitMessage(0);
			break;
	}

	return DefWindowProcW(hwnd, msg, wParam, lParam);
}

#endif
