#ifndef MAIN_H
#define MAIN_H

#define WINDOW_X 0
#define WINDOW_Y 0
#define WINDOW_WIDTH 350
#define WINDOW_HEIGHT 250

typedef enum {
    CBR_WINDOW_STYLE_FLAG_BORDERLESS = 0,
    CBR_WINDOW_STYLE_FLAG_TITLED = 1 << 0,
    CBR_WINDOW_STYLE_FLAG_CLOSABLE = 1 << 1,
    CBR_WINDOW_STYLE_FLAG_MINIATURIZABLE = 1 << 2,
    CBR_WINDOW_STYLE_FLAG_RESIZABLE = 1 << 3,
    CBR_WINDOW_STYLE_FLAG_FULL_SCREEN = 1 << 14,
} CBR_WindowStyleFlag;

typedef struct {
    float x;
    float y;
    float width;
    float height;
} CBR_Rect;

typedef struct {
    CBR_Rect rect;
    CBR_WindowStyleFlag style_flags;
    const char* title;
		void* params;
} CBR_CreateWindowParams;

void* CBR_CreateWindow(CBR_CreateWindowParams);

#endif
